; semi-parallel assembly code for N element floating point dot product
; A4 and B4 contain pointers to arrays of floats
; A6 contains an integer with N 
			.def 	_dotproduct2

_dotproduct2:
			MV		.S1		A6, A1		; copy count to register A1
||			ZERO	.L1		A8			; zero accumulator
LOOP:
			LDW		.D1		*A4++, A2	; get element from first array
||			LDW		.D2		*B4++, B2	; get element from second array
			SUB		.S1		A1, 1, A1	; decrement counter
			NOP		2					; wait for data
	[A1]	B		.S2		LOOP		; conditional branch
			MPYSP	.M1x	A2, B2, A7	; multiply 
			NOP	    3					; wait for result
			ADDSP	.L1		A7, A8, A8	; accumulate
			; conditional branch occurs here
			B		B3					; branch back to calling function
			NOP		2
			MV		.S1	A8, A4			; put result in proper register
			NOP		2

			.end